/**
 * Copyright (c) 2020 QingLang, Inc. <baisui@qlangtech.com>
 *
 * This program is free software: you can use, redistribute, and/or modify
 * it under the terms of the GNU Affero General Public License, version 3
 * or later ("AGPL"), as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package com.qlangtech.tis.fullbuild.taskflow;

import com.qlangtech.tis.fs.IFs2Table;
import com.qlangtech.tis.fs.ITaskContext;
import com.qlangtech.tis.fullbuild.phasestatus.IJoinTaskStatus;
import com.qlangtech.tis.sql.parser.ISqlTask;

/**
 * 执行打宽表任务
 *
 * @author 百岁（baisui@qlangtech.com）
 * @date 2015年10月31日 下午10:14:48
 */
public interface ITaskFactory {

    /**
     * 创建打宽表join节点
     *
     * @param nodeMeta
     * @param isFinalNode    是否是DF的最终节点
     * @param tplContext
     * @param taskContext
     * @param fs2Table
     * @param joinTaskStatus
     * @return
     */
    public DataflowTask createTask(ISqlTask nodeMeta, boolean isFinalNode, ITemplateContext tplContext, ITaskContext taskContext, IFs2Table fs2Table, IJoinTaskStatus joinTaskStatus);
}
